//============================================================
// COOOL           version 1.1           ---     Nov,  1995
//   Center for Wave Phenomena, Colorado School of Mines
//============================================================
//
//   This code is part of a preliminary release of COOOL (CWP
// Object-Oriented Optimization Library) and associated class 
// libraries. 
//
// The COOOL library is a free software. You can do anything you want
// with it including make a fortune.  However, neither the authors,
// the Center for Wave Phenomena, nor anyone else you can think of
// makes any guarantees about anything in this package or any aspect
// of its functionality.
//
// Since you've got the source code you can also modify the
// library to suit your own purposes. We would appreciate it 
// if the headers that identify the authors are kept in the 
// source code.
//
//=============================
// Definition of the LineSearchOptima class
// General information on the convergence of the optimization modules
// Author:  H. Lydia Deng /03/15/94
//=============================

#include "LSearchOptima.hh"

namespace coool 
{
    using namespace coool;
    
LineSearchOptima::LineSearchOptima(LineSearch* p) 
: NonQuadraticOptima()
{
    ls	=	p;
}

LineSearchOptima::LineSearchOptima(LineSearch* p, int verb)
: NonQuadraticOptima(verb)
{
    ls	=	p;
}

LineSearchOptima::~LineSearchOptima()
{
    if (ls != NULL) ls = NULL;
}
 
}

