#include "vuSphVwFlt_Lazy.h"

template <int S, class T>
vuSphVwFlt_Lazy<S,T>::vuSphVwFlt_Lazy()
{
}

template <int S, class T>
vuSphVwFlt_Lazy<S,T>::vuSphVwFlt_Lazy(const vuString& filterName)
  : vuSphericViewFilter<S,T>(filterName)
{
}

template <int S, class T>
vuSphVwFlt_Lazy<S,T>::~vuSphVwFlt_Lazy()
{
}

template <int S, class T>
void vuSphVwFlt_Lazy<S,T>::filter(vuCamera *camera)
{
  if (m_NumberOfViews > 0) {
    vuFixelMap<S,T> *map = m_Views[0]->getMap();
   
    ensureImage(map->getWidth(), map->getHeight());
    *m_Image  = *map;
  }
  else
    log("vuSphVwFlt_Lazy.filter(): no views set");
}

