#ifndef _VUVOLUMEFOURIER_H_
#define _VUVOLUMEFOURIER_H_

#include "../volume.h"

class vu17;
typedef vu17 vuVolumeFourier;

//!The base class for fourier volume data in the vuVolume data tree.

class vu17 : public vu1
{
protected:
    //!Asserts that the file is fourier data and reads the associated
    //!information.

    /*!This method reads in the general information for all fourier data sets.
       It also asserts whether the data is indeed fourier or not.
       \return True if successful (data is fourier), false otherwise.
    */
    virtual bool read(FILE *file);
    //!Writes the general fourier data information to the file.
    /*!\return True if successful, false otherwise.
    */
    virtual bool write(FILE *file);
};

#endif
