#ifndef _VU_VOLUME_LIGHTFIELD_UNIMODAL_SphLfFlt_All_H_
#define _VU_VOLUME_LIGHTFIELD_UNIMODAL_SphLfFlt_All_H_

#include "../vuSphericFilter.h"

template <int SIZE, class TYPE>
class vuSphLfFlt_All : public vuSphericFilter<SIZE,TYPE>
{
 protected:
  using vuSphericFilter<SIZE,TYPE>::m_volume;
  using vuSphericFilter<SIZE,TYPE>::getNearestViews;
 public:
  vuSphLfFlt_All(const vuString& filterName);

  //! This filter simple choses all views
  void calcFilteredViews(vuSphericView<SIZE,TYPE>**& views, dword& count);
};

template class vuSphLfFlt_All<1,byte>;
template class vuSphLfFlt_All<2,byte>;
template class vuSphLfFlt_All<3,byte>;
template class vuSphLfFlt_All<1,float>;
template class vuSphLfFlt_All<2,float>;
template class vuSphLfFlt_All<3,float>;

typedef vuSphLfFlt_All<1,byte>  vuSphLfFlt_All1B;
typedef vuSphLfFlt_All<2,byte>  vuSphLfFlt_All2B;
typedef vuSphLfFlt_All<3,byte>  vuSphLfFlt_All3B;
typedef vuSphLfFlt_All<1,float> vuSphLfFlt_All1F;
typedef vuSphLfFlt_All<2,float> vuSphLfFlt_All2F;
typedef vuSphLfFlt_All<3,float> vuSphLfFlt_All3F;

#endif /* _VU_VOLUME_LIGHTFIELD_UNIMODAL_SphLfFlt_All_H_ */
