#ifndef _VU_VOLUME_LIGHTFIELD_UNIMODAL_SphLfFlt_Z_Axis_H_
#define _VU_VOLUME_LIGHTFIELD_UNIMODAL_SphLfFlt_Z_Axis_H_

#include "../vuSphericFilter.h"

template <int SIZE, class TYPE>
class vuSphLfFlt_Z_Axis : public vuSphericFilter<SIZE,TYPE>
{
 protected:
  using vuSphericFilter<SIZE,TYPE>::m_volume;
  using vuSphericFilter<SIZE,TYPE>::getNearestViews;
 public:
  vuSphLfFlt_Z_Axis(const vuString& filterName);

  void calcFilteredViews(vuSphericView<SIZE,TYPE>**& views, dword& count);
};

template class vuSphLfFlt_Z_Axis<1,byte>;
template class vuSphLfFlt_Z_Axis<2,byte>;
template class vuSphLfFlt_Z_Axis<3,byte>;
template class vuSphLfFlt_Z_Axis<1,float>;
template class vuSphLfFlt_Z_Axis<2,float>;
template class vuSphLfFlt_Z_Axis<3,float>;

typedef vuSphLfFlt_Z_Axis<1,byte>  vuSphLfFlt_Z_Axis1B;
typedef vuSphLfFlt_Z_Axis<2,byte>  vuSphLfFlt_Z_Axis2B;
typedef vuSphLfFlt_Z_Axis<3,byte>  vuSphLfFlt_Z_Axis3B;
typedef vuSphLfFlt_Z_Axis<1,float> vuSphLfFlt_Z_Axis1F;
typedef vuSphLfFlt_Z_Axis<2,float> vuSphLfFlt_Z_Axis2F;
typedef vuSphLfFlt_Z_Axis<3,float> vuSphLfFlt_Z_Axis3F;

#endif /* _VU_VOLUME_LIGHTFIELD_UNIMODAL_SphLfFlt_Z_Axis_H_ */
