#ifndef _VUVOLUMEREGULARUNIMODAL3D1BINTENSITY_H_
#define _VUVOLUMEREGULARUNIMODAL3D1BINTENSITY_H_

#include "../1B.h"
#include "vuTFunc/vuTFIntensity.h"

//!The base class for visualization approaches using simple intensity transfer functions.

class vu111211;
typedef vu111211 vuVolumeRegularUnimodal3d1BIntensity;

//!The base class for visualization approaches using simple intensity transfer functions.

class vu111211 : public vu11121
{
public:
    //!Sets the transfer function for the instance.
    /*!Only the basic transfer function data is copied over, so other
       transfer function specific data is not stored.  Note that some
       rendering implementations, i.e. levels further down the tree,
       actually change the volume data based on the transfer function.
       In these cases, the transfer function must be set before
       the volume data is read, and should not be changed later on.
    */
    void setTransferFunc(const vuTFIntensity& tf);
    //!Returns the transfer function for the instance.
    const vuTFIntensity &getTransferFunc() const;

protected:
    //!The transfer function.
    vuTFIntensity m_TFunc;
};

#endif
