#ifndef _VUVOLUMEREGULAR_H_
#define _VUVOLUMEREGULAR_H_

#include "../volume.h"

class vu11;
typedef vu11 vuVolumeRegular;

//!The base class for regular volume data in the vuVolume data tree.

class vu11 : public vu1
{
protected:
    //!Asserts that the file is regular data and reads the associated information.
    /*!This method reads in the general information for all regular data sets.
       It also asserts whether the data is indeed regular or not.
       \return True if successful (data is regular), false otherwise.
    */
    virtual bool read(FILE *file);
    //!Writes the general regular data information to the file.
    /*!\return True if successful, false otherwise.
    */
    virtual bool write(FILE *file);
};

#endif
