/** \file
 *
 * This is the main program of the GUI Tool.
 *
 * It gets the gui tool running and passes it any command line parameters.
 * The vuMainWindow instance then takes control of the program.
 */

#include <wx/wx.h>
#include <wx/image.h>
#include "vuMainWindow.h"

//----------------------------------------------------------------------------
//------------------------- The wxApp application class ----------------------
//----------------------------------------------------------------------------

//! The application class defined according to the architecture for wxWindows.

/*! This class represents the main program of the GUI Tool.  It is derived from
    the wxApp class of the wxWindows library.  For more information see
    www.wxwindows.org
*/



// Define a new application type
class vuGUI : public wxApp
{
public:
    //! The initialization/starting function of the program.
    /*! It passes on the initialization to the vuMainWindow class */
       bool OnInit();

private:
    //! The vuMainWindow instance for the program.
    vuMainWindow *m_Main;
};

